﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System.ComponentModel.Composition;

namespace MEF_Hello_World.More.Test
{
    [TestClass]
    public class MEF_Hello_World
    {
        [TestMethod]
        public void MEF_Hello_World_TestMethod()
        {
            var catalog = new AttributedTypesPartCatalog(typeof(Foo), typeof(BarWithSingleFoo));
            var container = new CompositionContainer(catalog.CreateResolver());

            var bar = new BarWithSingleFoo();
            var foo = new Foo();

            container.AddPart(bar);
            container.AddPart(foo);

            container.Compose();

            Assert.IsNotNull(bar.Foo);
            Assert.AreSame(foo, bar.Foo);
            
            Console.Write("Hello World! No Error Found!");

        }

        [TestMethod]
        [ExpectedException(typeof(CompositionException))]
        public void AddingOnlyOneOfThePartsFails()
        {
            var catalog = new AttributedTypesPartCatalog(typeof(Foo), typeof(BarWithSingleFoo));
            var container = new CompositionContainer(catalog.CreateResolver());

            var bar = new BarWithSingleFoo();

            container.AddPart(bar);
            container.Compose();
        }

        [TestMethod]
        public void AddingNoExportPartsForImportingCollectionIsOK()
        {
            var catalog = new AttributedTypesPartCatalog(typeof(Foo), typeof(BarWithManyFoos));
            var container = new CompositionContainer(catalog.CreateResolver());

            var bar = new BarWithManyFoos();

            container.AddPart(bar);
            container.Compose();
        }

        //[TestMethod]
        //public void AddingOneFooToBarWithManyFoos()
        //{
        //    var catalog = new AttributedTypesPartCatalog(typeof(Foo), typeof(BarWithManyFoos));
        //    var container = new CompositionContainer(catalog.CreateResolver());

        //    var bar = new BarWithManyFoos();
        //    var foo = new Foo();

        //    container.AddPart(bar);
        //    container.AddPart(foo);
        //    container.Compose();

        //    Assert.AreEqual(1, bar.Foos.Count());
        //    Assert.AreSame(foo, bar.Foos.First());
        //}

    }
}
